﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Threading;
using AsyncWebPart;

namespace AsyncWebPart2013.SampleTwo
{
    [ToolboxItemAttribute(false)]
    public class SampleTwo : AsyncWebPartBase
    {
        Label _lblTwo;

        protected override void CreateChildControls()
        {
            this.CssClass = "SampleTwoWebPart";
            // Remember this gets executed twice
        }

        protected override void RunProcesses()
        {
            Thread.Sleep(8000);
            _lblTwo = new Label();
            _lblTwo.Text = "Async Content Goes Here...";
            this.Controls.Add(_lblTwo);
        }

        protected override void RenderAsync(HtmlTextWriter writer)
        {
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "SampleTwo");
            writer.RenderBeginTag(HtmlTextWriterTag.Span);
            _lblTwo.RenderControl(writer);
            writer.RenderEndTag();
        }
    }
}
